#ifndef _IP_CONNTRACK_SIP_H
#define _IP_CONNTRACK_SIP_H
/* SIP tracking. */

#ifdef __KERNEL__
DECLARE_LOCK_EXTERN(sipbf_lock);

#define SIP_PORT	5061
#define SIP_TIMEOUT	3600

#define POS_VIA		0
#define POS_CONTACT	1
#define POS_CONTENT	2
#define POS_MEDIA	3
#define POS_OWNER	4
#define POS_CONECTION	5
#define POS_REQ_HEADER	6
#define POS_SDP_HEADER	7
#define POS_WARNING_SRC_IP	8
#define POS_WARNING_SRC_PORT	9
#define POS_CALL_ID_HEADER		10
#endif /* __KERNEL__ */

/*gordon add*/
#define 	CONTACT_FLAG   	0x01   	/*the packet's contact field contains port*/
	
#define 	VIA_FLAG		0x02	/*the packet's via field contains port*/
	
#define		MEDIA_FLAG		0x04	/*the packet's media field contains port*/

#define     CONTACT_IN_EXP	0x08	/*the packet's contact field will be generated an exp*/

#define     VIA_IN_EXP		0x10	/*the packet's via field will be generated an exp*/

struct ip_ct_sip_expect
{
	u_int32_t offset;   /*the offset from data header to match patern*/
	u_int32_t ipaddr_sip;/*sip ipaddr in the udp*/
	u_int32_t len;			/* length of IP address */
	u_int16_t port; 		/* UDP port that was to be used */
	u_int16_t via_port;
	u_int16_t contact_port;
	unsigned char flag_port_contant;
	unsigned char current_flag;

};

/*gordon at the end of the add*/

struct sip_header_nfo {
	const char *lname;
	size_t lnlen;
	const char *sname;
	size_t snlen;
	const char *ln_str;
	size_t ln_strlen;
	int (*match_len)(const char *, const char *, int *, u_int16_t *);

};

/* extern int ip_ct_remove_expectations(struct ip_conntrack *ct); */
extern void ip_nat_set_timeout_by_master(struct ip_conntrack *master,
				unsigned int timeout,
				struct ip_conntrack_tuple *tuple,
				struct ip_conntrack_tuple *mask);

extern int ct_sip_get_info(const char *dptr, size_t dlen, 
				unsigned int *matchoff, 
				unsigned int *matchlen, 
				struct sip_header_nfo *hnfo,
				u_int16_t *port);
/* get line lenght until first CR or LF seen. */
static inline int ct_sip_lnlen(const char *line, const char *limit)
{
        const char *k = line;

        while ((line <= limit) && (*line == '\r' || *line == '\n'))
                line++;

        while (line <= limit) {
                if (*line == '\r' || *line == '\n')
                        break;
                line++;
        }
        return line - k;
}

/* Linear string search, case sensitive. */
static inline
const char *ct_sip_search(const char *needle, const char *haystack, 
			size_t needle_len, size_t haystack_len) 
{
	const char *limit = haystack + (haystack_len - needle_len);

	while (haystack <= limit) {
		if (memcmp(haystack, needle, needle_len) == 0)
			return haystack;
		haystack++;
	}
	return NULL;
}

#endif /* __IP_CONNTRACK_SIP_H__ */
